﻿
string[] fileTypesToSearchFor = [".cs", ".csproj", ".ts", ".js", ".css", ".html", ".cshtml", ".sql", ".json", ".xml"];
RepoStatistics repoStatistics = new RepoStatistics();
var repoAndDirectories = repoStatistics.GetRepoAndDirectories(@"c:\dev\github\polly");

foreach(var repoAndDirectory in repoAndDirectories)
{
    var dirResult = repoStatistics.ProcessDirectory(repoAndDirectory.DirectoryPath, fileTypesToSearchFor);
    repoAndDirectory.RepoResult = dirResult;
}

foreach (var repoAndDirectory in repoAndDirectories)
{
    Console.WriteLine($"Repo: {repoAndDirectory.RepoName}");
    Console.WriteLine($"Directory: {repoAndDirectory.DirectoryPath}");
    Console.WriteLine();
    foreach (var repoResult in repoAndDirectory.RepoResult.OrderByDescending(kv => kv.Value.TotalLines))
    {

        Console.WriteLine($"File type: {repoResult.Key}");
        Console.WriteLine($"File count: {repoResult.Value.FileCount}");
        Console.WriteLine($"Total lines: {repoResult.Value.TotalLines}");
        if (repoResult.Key == ".cs")
        {  
            Console.WriteLine($"Code lines: {repoResult.Value.TotalLines - repoResult.Value.BlankLines - repoResult.Value.BraceLines - repoResult.Value.CommentedLines}");
            Console.WriteLine($"Commented lines: {repoResult.Value.CommentedLines}");
            Console.WriteLine($"Brace only lines: {repoResult.Value.BraceLines}");
        }
        Console.WriteLine($"Blank lines: {repoResult.Value.BlankLines}");
        Console.WriteLine();
    }
    Console.WriteLine("-------------------------------------------------\n-------------------------------------------------\n");
}